
// Последнее обновление 2018-07-25 by Phisik
// В рамках разгрузки кода раскидываем функции по файлам
// Обработка клавиатуры здесь

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Очень длинная и "нудная" функция обработки клавиатуры в разных режимах (автору респект!)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "configuration.h"
#include "declarations.h"

char KeyCode; // Код нажатой клавиши

#define PRESS_SELECT     (KeyCode==1)  // Phisik: Скобочки здесь нужно всегда ставить, на всякий случай,
#define PRESS_RIGHT      (KeyCode==2)  // т.к. могут быть очень трудноуловимые ошибки
#define PRESS_LEFT       (KeyCode==3)
#define PRESS_UP         (KeyCode==4)
#define PRESS_DOWN       (KeyCode==5)

void ScanKbd()
{
  char i;
  // Если режим защиты от дребезга уже выключен
  if (CountKeys == 0)
  {
    flScanKbd = 1; // Установим признак сканирования клавиатуры.
    KeyCode = 0; // Reset keycode

    switch (cmdWiFi) {
      case 'R': KeyCode = 2; break;
      case 'U': KeyCode = 4; break;
      case 'D': KeyCode = 5; break;
      case 'L': KeyCode = 3; break;
      case 'S': KeyCode = 1; break;
    }
    cmdWiFi = 0;  // clear server command

#if USE_LCD_KEYPAD_SHIELD
    // Skip hardware keyboard reading if recieved online command
    if (KeyCode == 0) {
      const int key = analogRead(PIN_LCD_KEYPAD);
      if (key >= 0)    KeyCode = 2;
      if (key >= 90)   KeyCode = 4;
      if (key >= 200)  KeyCode = 5;
      if (key >= 400)  KeyCode = 3;
      if (key >= 600)  KeyCode = 1;
      if (key >= 1000) KeyCode = 0;
    }
#else
    //   Проверка на соответствие HIGH. Также можно использовать 1
    if(digitalRead(PIN_SELECT)==1) KeyCode = 1;
    if(digitalRead(PIN_RIGHT)==1)  KeyCode = 2;
    if(digitalRead(PIN_LEFT)==1)   KeyCode = 3;
    if(digitalRead(PIN_UP)==1)     KeyCode = 4;
    if(digitalRead(PIN_DOWN)==1)   KeyCode = 5;

#endif

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // PRESS_LEFT && PRESS_RIGHT
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (PRESS_LEFT && PRESS_RIGHT)
    {
      if (BeepKeyPress) my_beep(2);
      lcd.begin(LCD_WIDTH, LCD_HEIGHT);
      lcd.clear();
      DisplayData();
    }
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //  PRESS_UP && PRESS_DOWN
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    // Нажатие кнопок одновременно вверх и вниз позволяет перейти к следующему этапу (отладочные кнопки)
    if (PRESS_UP && PRESS_DOWN)
    {
      if (BeepKeyPress) my_beep(2);
      StateMachine++; // Состояние конечного автомата процесса ректификации
      CountKeys = 10; // Большая защита от дребезга, чтоб случайно не нажали.
      DisplayData();
      time1 = 0;
      time2 = 0;
      time3 = 0;
    }
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //  PRESS_SELECT
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    if (PRESS_SELECT)
    {
      if (BeepKeyPress) my_beep(1);
      switch (FlState)
      {
        case 0:
          FlState = IspReg;
          break;
        case 100:
        FlState=200;      
        break;   
        case 101:
          FlState = 0;
          IspReg = 101;
          writeEEPROM();
          break;
        case 102:
          if (IspReg != 102)
          {
            Seconds = 0;
            StateMachine = 0;
          }
          if (!StateMachine) StateMachine = 1;
          IspReg = 102;
          writeEEPROM();
          FlState = 200;
          break;
        case 200:
          FlState = 0;
          writeEEPROM();
          break;
        case 103:
          IspReg = 103;
          writeEEPROM();
          FlState = 202;
          break;
        case 201:
          writeEEPROM();
          FlState = 0;
          break;
        case 202:
          writeEEPROM();
          FlState = 0;
          break;
        case 104:
          // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
          if (IspReg != 104 || !StateMachine)
          {
            Seconds = 0;
            StateMachine = 0;
          }
          if (!StateMachine) StateMachine = 1;
          IspReg = 104;
          writeEEPROM();
          FlState = 205;
          break;
        case 105:
          // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
          if (IspReg != 105 || !StateMachine)
          {
            Seconds = 0;
            StateMachine = 0;
          }
          if (!StateMachine) StateMachine = 1;
          IspReg = 105;
          writeEEPROM();
          FlState = 206;
          break;
        case 106:
          // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
          if (IspReg != 106 || !StateMachine)
          {
            Seconds = 0;
            StateMachine = 0;
          }
          if (!StateMachine) StateMachine = 1;
          IspReg = 106;
          writeEEPROM();
          FlState = 207;
          break;

        case 203:
        case 204:
        case 205:
        case 206:
        case 207:
        case 210:
        case 211:
        case 212:
        case 213:
        case 214:
        case 215:
        case 216:
          writeEEPROM();
          FlState=0;
          break;    
        case 208:
          FlState = 300;
          nPopr = 0;
          break;
        case 209:
          FlState = 309;
          nPopr = 0;
          flPopr = 0;
          break;

        case 300:
          writeEEPROM();
          FlState = 208;
          break;
        case 309:       
          writeEEPROM();
          FlState=209;
          break;    
      }
      DisplayData();
      CountState = 4;
      if (CountKeys == 0) CountKeys = 6;
      CountState = 10;
    }
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //  PRESS_RIGHT
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (PRESS_RIGHT)
    {
      if (BeepKeyPress) my_beep(1);

      switch (FlState)
      {
        case 0:
        if (DispPage<4) DispPage++;
        // Если перешли на 4 страницу, то переинициализируем дисплей
        if (DispPage==4)
        {
            my_beep(BEEP_LONG);
            lcd.init();
            lcd.clear();
          DisplayData();
        }
        CountKeys=4;              
        break;
// case 100:  Settings  
// case 101:  Monitoring  
// case 102:  Thermostat
// case 103:  Power Regulator
// case 104:  1st distillation
// case 105:  2 DR otbor
// case 106:  3 DR otbor

        case 101:
        case 102:
        case 103:
        case 104:
        case 105:
        case 106:
        FlState--;
        break;
        case 100:
        FlState=106;
        break;    

        case 200:
        case 201:
        case 202:
        case 203:
        case 204:
        case 205:
        case 206:
        case 207:
        case 208:
        case 209:
        case 210:
        case 211:
        case 212:
        case 213:
        case 214:
        case 215:
        FlState++;
        break;
      case 216:
        FlState=200;
        break;

        case 300:
          if (nPopr < MAX_DS1820 - 1) nPopr++;
        CountState=8; // При вводе поправок сохраняем состояние 4 секунды, а не две, тут спешка не нужна.                
        CountKeys=4;
          break;
        case 303:
          if (nPopr < 3) nPopr++;
          break;
        case 304:
          if (nPopr < 9) nPopr++;
          break;
        case 305:
          if (nPopr < 11) nPopr++;
          break;
        case 309:
          if (nPopr < 2) nPopr++;
          break;
      }
      //NeedDisplaying=1;
      DisplayData();
      if (CountKeys == 0) CountKeys = 6;
      CountState = 4;
      CountState = 40;
    }
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //  PRESS_LEFT
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (PRESS_LEFT)
    {
      if (BeepKeyPress) my_beep(1);
      switch (FlState)
      {
        case 0:
        if (DispPage>0) DispPage--;
        else
        { // Если на нулевой странице нажали кнопку влево, то тоже переинициализируем дисплей. 
          my_beep(BEEP_LONG*2);
            lcd.init();
            lcd.clear();
          DisplayData();
        }
          CountKeys = 4;
          break;
// case 100:  Settings  
// case 101:  Monitoring  
// case 102:  Thermostat
// case 103:  Power Regulator
// case 104:  1st distillation
// case 105:  2 DR otbor
// case 106:  3 DR otbor

        case 101:
        case 102:
        case 103:
        case 104:
        case 105:
        case 106:
        FlState--;
        break;
        case 100:
        FlState=106;
        break;
        
        case 201:
        case 202:
        case 203:
        case 204:
        case 205:
        case 206:
        case 207:
        case 208:
        case 209:
        case 210:
        case 211:
        case 212:
        case 213:
        case 214:
        case 215:
        case 216:
        FlState--;
        break;
        case 200:
        FlState=216;
        break;     

        case 300:
          if (nPopr > 0) nPopr--;
          break;
        case 301:
          if (flPopr == 1) flPopr = 0;
          else
          {
            if (nPopr > 0) nPopr--;
            flPopr = 1;
          }
          break;
        case 302:
          if (flPopr == 1) flPopr = 0;
          else
          {
            if (nPopr > 0) nPopr--;
            flPopr = 1;
          }
        case 303:
        case 304:
        case 305:
        case 309:
        case 310:
        case 311:
          break;
      }
      DisplayData();
      flNeedAnalyse = 1;
      CountState = 4;
      CountState = 40;
      if (CountKeys == 0) CountKeys = 6;
    }
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //  PRESS_UP
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (PRESS_UP)
    {
      if (BeepKeyPress) my_beep(1);
      CountState = 0;
      switch (FlState)
      {
        case 0:
          if (DispPage == 3) // На 3 странице можно мощность вручную изменить.
          {
            UstPower += 10;
            break;
          }
          if (DispPage == 4) // На 5 странице можно состояние процессa поменять.
          {
            StateMachine++;
            break;
          }
          // Регулятор мощности
          if (IspReg == 103)
          {
            if (DispPage == 1)
            {
              // На второй странице нажатик кнопки "вверх" приводи к авто-детекции мощности ТЭНа
              flAutoDetectPowerTEN = 1;
            }
            else
            {
              UstPowerReg += 10;
              flAutoDetectPowerTEN = 0;
            }
            CountKeys = 1;
          }
          if (IspReg == 104)
          {
            CountKeys = 1;
            if (StateMachine == 2)
              TempDeflBegDistil++;
            else
            {
              if (DispPage == 0)  Temp1P++;
              else  PowerDistil += 10;
            }
          }
          if (IspReg == 105)
          {
            CountKeys = 1;
            if (StateMachine == 2)
              TempDeflBegDistil++;
            else
            {
              if (DispPage == 0)  Temp2P++;
              else  PowerDistil += 10;
            }
          }
          if (IspReg == 106)
          {
            CountKeys = 1;
            if (StateMachine == 2)
              TempDeflBegDistil++;
            else
            {
              if (DispPage == 0)  Temp3P++;
              else PowerDistil += 10;
            }
          }
        case 200:
          TempTerm += AddPressKeys;
          CountKeys = 2;
          break;
        case 201:
          Power += AddPressKeys10;
          UstPower = Power;
          CountKeys = 3;
          break;
        case 202:
          UstPowerReg += AddPressKeys10;
          CountKeys = 3;
          break;
        case 203:
          FlToUSART = 1;
          break;
        case 204:
          Delta++;
          CountKeys = 3;
          break;
        case 205:
          Temp1P += AddPressKeys;
          CountKeys = 2;
          break;
        case 206:
          Temp2P += AddPressKeys;
          CountKeys = 2;
          break;
        case 207:
          Temp3P += AddPressKeys;
          CountKeys = 2;
          break;
        case 209:
          PIDTemp[0] += AddPressKeys;
          CountKeys = 2;
          break;
        case 210:
          PowerDistil += AddPressKeys10;
          CountKeys = 3;
          break;
        case 211:
          TempDeflBegDistil += AddPressKeys;
          CountKeys = 3;
          break;
        case 212:
          BeepEndProcess = 1;
          break;
        case 213:
          BeepStateProcess++;
          CountKeys = 5;
          break;
        case 214:
          BeepKeyPress = 1;
          break;
        case 215:
          PowerTermostat += AddPressKeys10;
          CountKeys = 3;
          break;
        case 216:
          CorrectASC712++;
          CountKeys = 3;
          break;
        
        case 300:
          ds1820_popr[nPopr]++;
          CountState = 8;
          // При вводе поправок сохраняем состояние 4 секунды, а не две, тут спешка не нужна.
          CountKeys = 4;
          break;
        case 309:
          PIDTemp[nPopr] += AddPressKeys;
          CountKeys = 2;
          break;
      }
      DisplayData();
      flNeedAnalyse = 1;
      if (CountState == 0) CountState = 4;
      if (CountKeys == 0) CountKeys = 6;
      CountState = 40;
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //  PRESS_DOWN
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    if (PRESS_DOWN)
    {
      if (BeepKeyPress) my_beep(1);
      CountState = 0;
      switch (FlState)
      {
        case 0:
          if (DispPage == 3) // На 3 странице можно мощность вручную изменить.
           {
            UstPower -= 10;
            break;
          }
          if (DispPage == 4) // На 4 странице можно состояние процесса поменять.
          {
            StateMachine--;
            break;
          }
         // Регулятор мощности
          if (IspReg == 103)
          {
            UstPowerReg -= 10;
            CountKeys = 1;
          }
          if (IspReg == 104)
          {
            CountKeys = 1;
            if (StateMachine == 2)
              TempDeflBegDistil--;
            else if (DispPage == 0)  Temp1P--;
            else  PowerDistil -= 10;
          }
          if (IspReg == 105)
          {
            CountKeys = 1;
            if (StateMachine == 2)
              TempDeflBegDistil--;
            else if (DispPage == 0)  Temp2P--;
            else  PowerDistil -= 10;
          }
          if (IspReg == 106)
          {
            CountKeys = 1;
            if (StateMachine == 2)
              TempDeflBegDistil--;
            else if (DispPage == 0)  Temp3P--;
            else  PowerDistil -= 10;
          }
        case 200:
          TempTerm -= AddPressKeys;
          CountKeys = 2;
          break;
        case 201:
          Power -= AddPressKeys10;
          UstPower = Power;          
          CountKeys = 3;
          break;
        case 202:
          UstPowerReg -= AddPressKeys10;
          CountKeys = 3;
          break;
        case 203:
          FlToUSART = 0;
          break;
        case 204:
          Delta--;
          CountKeys = 3;
          break;
        case 205:
          Temp1P -= AddPressKeys;
          CountKeys = 2;
          break;
        case 206:
          Temp2P -= AddPressKeys;
          CountKeys = 2;
          break;
        case 207:
          Temp3P -= AddPressKeys;
          CountKeys = 2;
          break;
        case 209:
          PIDTemp[0] -= AddPressKeys;
          CountKeys = 2;
          break;
        case 210:
          PowerDistil -= AddPressKeys10;
          CountKeys = 3;
          break;
        case 211:
          TempDeflBegDistil -= AddPressKeys;
          CountKeys = 3;
          break;
        case 212:
          BeepEndProcess = 0;
          break;
        case 213:
          BeepStateProcess = 0;
          break;
        case 214:
          BeepKeyPress = 0;
          break;
        case 215:
          if (PowerTermostat > 10) PowerTermostat -= AddPressKeys10;
          else PowerTermostat = 0;
          CountKeys = 3;
          break;
        case 216:
          CorrectASC712--;
          CountKeys = 3;
          break;

        case 300:
          ds1820_popr[nPopr]--;
          CountState = 8; // При вводе поправок сохраняем состояние 4 секунды, а не две, тут спешка не нужна.
          CountKeys = 4;
          break;
        case 309:
          PIDTemp[nPopr]-=AddPressKeys;
          CountKeys=2;
          break;
      }
      DisplayData();
      flNeedAnalyse = 1;
      if (CountState == 0) CountState = 4;
      if (CountKeys == 0) CountKeys = 6;
      CountState = 40;
    }
    flNeedScanKbd = 0;
    flScanKbd = 0; // Убираем признак того, что сканируется клавиатура.
  }
}
