// Последнее обновление 2018-08-19 by Phisik
// Файл содержит дефолтные настройки системы
// Часть настроек меняется в файле configuration.h при выборе версий, внимательно с этим!

#define PR_REWRITE_EEPROM  1  // Константа, которая содержит признак необходимости перезаписи энергонезависимой памяти (1-254). 
// При запуске программы, значение 0-го байта ЕЕПРОМ сравнивается с этим значением,
// и если они не совпадают, тогда энергонезависимая памиять переписывается текущими значениями переменных
// То есть для значений переменных из скетча в контроллер, ее значение надо поменять например с 0 на 1.
//=======================================================================================================
// Phisik: настройка UART для работы с периферией

#define DEBUG_SERIAL			 Serial  // Куда выводить отладку
#define DEBUG_SERIAL_BAUDRATE	 115200

#define MQTT_SERIAL				 Serial3  // Порт, к которому подключена ESP, важно, чтобы не пересекалось с GSM_SERIAL
#define MQTT_SERIAL_BAUDRATE	 250000   // Ставим максимальную, при которой еще нет ошибок связи
#define USE_MQTT_BROKER          1  // MQTT protocol by max506 & limon
// В этом режиме для ESP надо использовать прошивку от limon или мою

#define MQTT_SERIAL_PING_CHECK   1  // Phisik: Попытка наладить связь между контроллерами при обрыве.
                //Работает только с моей прошивкой для ESP. С другими прошивками будет только мешать!
//=======================================================================================================
// НАСТРОЙКА ЭКРАНА И КНОПОК
// Phisik 2018-07-24: добавил I2C экран.
// Оригинал здесь http://forum.homedistiller.ru/msg.php?id=13320675

#define USE_LCD_KEYPAD_SHIELD   0    // 1 - использовать стандартный шильд - один пин A0 на все кнопки 
                                     // 0 - каждая кнопка привязана к своему пину
#define USE_I2C_LCD   1              // + много свободных пинов, - много лишних проводов
#define LCD_I2C_ADDRESS 0x27		     // У каждого конвертера I2C свой адрес. Используйте сканнер I2C.
// Поскольку у людей разные экраны, то лучше мы сделаем тут макрос
#define LCD_WIDTH  16
#define LCD_HEIGHT 2
// предполагаем 2 байта на символ, в международной кодировке (UTF8 может быть 1-4 байта на символ)
#define LCD_BUFFER_SIZE  (LCD_WIDTH*2+2)
//=======================================================================================================
// ОБЩИЕ НАСТРОЙКИ

#define BEEP_LONG		10          // Длительность сигнала оповещения о состояниях процесса
#define DEBOUNCE_CYCLES    10   // Число отсчетов таймера для устранения дребезга кнопок, 
#define NO_PAGE_BEEP			 0    // Не пищать на 0ой странице
#define USE_ASC712	       0    // Если USE_ASC712 = 0, то осуществляется фазовое регулирование
#define SENSITIVE_ASC712	 205  // Чувствительность датчика тока (показаний АЦП ардуино на 10 ампер тока 135 для 30А датчика, 205 для 20А датчика 82)
#define CNT_PERIOD       4			// Количество полу-периодов для обсчета среднеквадратичного
#define USE_DIFAVTOMAT   0			// Константа, которая показывает, используется ли дифавтомат в работе системы
#define ALL_OFF_HIGH     1			// Какой сигнал подавать на выход ALL_OFF

// ДАТЧИКИ ТЕМПЕРАТУРЫ
#define MAX_DS1820		3

// Phisik: update 2018-07-25
// Номера датчиков теперь приведены в порядок. Если датчики определяются не в том порядке, меняем числа тут

#define TEMP_KUB       0    // Номер датчика  термометра в кубе
#define TEMP_RK20      1    // Номер датчика термометра в РК 20 см от насадки
#define TEMP_TSA       2    // Номер термометра в трубке связи с атмосферой
#define TEMP_DEFL  TEMP_RK20    // Номер датчика  термометра в дефлегматоре
#define TEMP_TERMOSTAT 0    // Номер датчика  термометра термостата

#define MAX_TEMP_TSA    550	  // Максимальная температура в датчике ТСА
#define MAX_ERR_DS18    120   // После тридцати глюков подряд (а это тридцать секунд) от датчиков температуры, считаем, что процесс надо остановить.
#define MAX_INDEX_INPUT 540
#define MAX_INDEX_BY_PERIOD 90
#define MIN_INDEX_BY_PERIOD 75

//============================================
//       Справка по процессам     
//============================================
// case 100:  Settings  
// case 101:  Monitoring  
// case 102:  Thermostat
// case 103:  Power Regulator
// case 104:  1st distillation
// case 105:  2 DR otbor
// case 106:  3 DR otbor
//=========================================
//       Справка по МЕНЮ НАСТРОЕК
//=========================================
//  200: "Max_t_Tst
//  201: "Power TEN"
//  202: "Power Reg"
//  203: "ParamUSART"
//  204: "dtTermostat"
//  205: "Temp 1 Nedrobn Distill"
//  206: "Temp 2 Drobn Distill"
//  207: "Temp 3 Drobn Distill"
//  208: "Vvod Popravok ds18b20"
//  209: "PID Paramters"
//  210: "Power simple Distill"
//  211: "Temp Begin Dist (+Def -Kub)"
//  212: "BeepEndProc"
//  213: "BeepStateProc"
//  214: "BeepKeyPress"
//  215: "PowerTermostat"
//  216: "Power correct ASC712"
//===============================================
//          Экраны дисплея
//===============================================
//  D1   hour, minute, second, TicZero, MaxVoltsOut.
//  D2   TEMP_KUB, TEMP_DEFL, TEMP_TSA.
//  D3   UstPower, MaxVoltsOut, MaxIOut.
//  D4   zPSOut, UstPower
//  D5   StateMachine и смена состояния процесса.
